<template>
    <div class="page-gmaps scrollable ">
        <div class="card-base card-shadow--medium map-app">
            <gmap-map ref="map"
                      :center="(location && location.lat != null && location.lng != null ) ? location : center"
                      :zoom="12"
                      map-type-id="roadmap"
                      :options="option"
                      style="width: 40%; height: 150px; bottom: 0px; position: absolute;"
            >
                <GmapMarker v-if="location" :position="(location && location.lat != null && location.lng != null ) ? location : center" label="" />
            </gmap-map>
        </div>
    </div>
</template>

<script>
    import Vue from "vue";
    const EventBus = new Vue();
    import {loaded} from 'vue2-google-maps'
    import $ from 'jquery';
    export default {
        name: 'GMaps',
        props: [
            "location",
        ],
        data () {
            return {
                lastId: 1,
                center: {
                    lat: 0,
                    lng: 0
                },
                mapBounds: {},
                zoom: 7,
                option: {
                    gestureHandling:'none'
                }
            }
        },
        created() {
            EventBus.$on("bounds_changed", () => {
                // put your operation in vue here
            });
        },
        methods: {
            init(){
                this.$refs.map.$mapPromise.then((map) => {
                    //console.log(window.google);
                    window.google.maps.event.addListener( this.$refs.map, 'bounds_changed', this.onBoundsChanged() );
                })
            },
            onBoundsChanged(map) {
                // console.log(map.getDiv());
                // if ( $(map.getDiv()).children().eq(0).height() == window.innerHeight &&
                //     $(map.getDiv()).children().eq(0).width()  == window.innerWidth ) {
                //     console.log( 'FULL SCREEN' );
                // }
                // else {
                //     console.log ('NOT FULL SCREEN');
                // }

                console.log("onchange");
                EventBus.$emit("bounds_changed");
            }
        },
        mounted(){
            this.init();
            // let google = gmapApi;
            //
        }

    }
</script>

<style lang="scss" scoped>
    @import '../../../assets/scss/_variables';

    .page-gmaps {
        .map-app {
            max-height: 500px;

            .settings-panel {
                box-sizing: border-box;
                max-width: 400px;

                ul, li, select, button {
                    font-size: 10px;
                }

                h3 {
                    margin-bottom: 0px;
                }
                ul {
                    margin-top: 15px;
                }
                [type="checkbox"] {
                    position: relative;
                    top: 2px;
                }
                li {
                    margin-bottom: 2px;
                }
                pre {
                    max-height: 200px;
                    overflow: auto;
                }

                .marker-box {
                    background: $background-color;
                    padding: 10px;
                    box-sizing: border-box;
                    list-style: none;

                    li, select, button {
                        font-size: 14px;
                    }
                }
            }
        }
    }


    @media (max-width: 768px) {
        .page-gmaps {
            .map-app {
                max-height: inherit !important;
                display: block;

                .settings-panel, .map-panel {
                    display: block;
                    overflow: hidden;
                    width: 100%;
                    max-width: 100%;
                    height: 400px;
                }
                .settings-panel {
                    overflow: auto;
                }
            }
        }
    }
</style>
<style lang="scss">
    .page-gmaps {
        .map-app {

            .settings-panel {

                [type="text"] {
                    background-color: rgba(255, 255, 255, 0.2);
                    border: 1px solid rgba(255, 255, 255, 0.3);
                }
            }
        }
    }
    .gm-style .gm-style-iw {
        color: black;
    }
</style>


